import cv2 as cv
import numpy as np
from maxRectAprox import maxRect
from cvFuns import pathPoint, startCorner, increment_mar
import math


def lakkeringsbane(img, name, aks, diameter, overlapp=0, smaaObjekt=True, inkX=3, inkY=3, inkVink=3, margin=3):

    def paintRecRot(img, maxPoints, clr, thickness):

        # maxPoints = [int(round(x)) for x in maxPoints]
        cv.line(img, tuple(maxPoints[0][0]), tuple(maxPoints[1][0]), clr, thickness)
        cv.line(img, tuple(maxPoints[1][0]), tuple(maxPoints[3][0]), clr, thickness)
        cv.line(img, tuple(maxPoints[0][0]), tuple(maxPoints[2][0]), clr, thickness)
        cv.line(img, tuple(maxPoints[2][0]), tuple(maxPoints[3][0]), clr, thickness)

    def uVectDrawLine(a, b, length, img, lineWidth):
        ab = math.sqrt(((b[0] - a[0]) ** 2) + ((b[1] - a[1]) ** 2))
        u = ((b[0] - a[0]) / ab, (b[1] - a[1]) / ab)
        pPos = (int(round(a[0] + u[0] * length)), int(round(a[1] + u[1] * length)))
        pNeg = (int(round(a[0] + u[0] * length * -1)), int(round(a[1] + u[1] * length * -1)))
        ## Try to optimalize
        hh, ww = img.shape[:2]

        ##
        cv.line(img, pPos, pNeg, 0, lineWidth)

    if diameter <= overlapp:
        print("**ERROR: Overlapp kan ikke være større eller lik diameter**")
        cv.destroyAllWindows()
        return 0

    if (inkY | inkX | inkVink | diameter) <= 0:
        print("**ERROR: Diameter, inkrement X, Y eller rotering kan ikke være null eller mindre**")
        cv.destroyAllWindows()
        return 0

    if overlapp < 0:
        print("**ERROR: Overlapp kan ikke ha negativ verdi**")
        cv.destroyAllWindows()
        return 0

    print("Figur navn: ", name)

    # convert to grayscale
    gray = cv.cvtColor(img, cv.COLOR_BGR2GRAY)

    # threshold
    thresh = cv.threshold(gray, 10, 255, cv.THRESH_BINARY)[1]

    # get contours and get the largest and smallest ones
    contour_img = img.copy()
    contours_compl = cv.findContours(thresh, cv.RETR_TREE, cv.CHAIN_APPROX_NONE)

    if len(contours_compl[0]) == 0:
        print("**ERROR: Finner ingen objekt **")
        return 0
    hh, ww = img.shape[:2]
    diagonal = math.sqrt(hh ** 2 + ww ** 2)
    contours = contours_compl[0] if len(contours_compl) == 2 else contours_compl[1]

    rect = cv.minAreaRect(contours[0])
    storRektangel = rect[1][0] * rect[1][1]

    min_area_thresh = hh * ww
    max_area_thresh = 0
    for cntr in contours:
        cv.drawContours(contour_img, [cntr], -1, (0, 255, 0), 1)
        area = cv.contourArea(cntr)
        if area < min_area_thresh:
            min_area_thresh = area

        if area > max_area_thresh:
            max_area_thresh = area

    thresh2 = thresh.copy()
    thresh3 = thresh.copy()
    lineWidth = 2

    childrenSize = 0
    estChildrenSize = 0
    # Sjekker om kontur inneholder vindu
    if len(contours) > 1:
        # scan contours_compl[1][0][i][3]
        ###
        lst = []
        # Find all contours with parents and put index number in lst
        for i in range(0, len(contours_compl[1][0])):
            if not contours_compl[1][0][i][3] == -1:
                lst.append(i)
        ###
        # stick up all contours with parents -> windows
        for i in lst:
            contour = contours_compl[0][i]
            childrenSize += cv.contourArea(contour)
            drawPolyCntr = True
            if drawPolyCntr:
                cntCount = len(contour)
                x = 0
                y = 0

                for kp in contour:
                    x = x + kp[0][0]
                    y = y + kp[0][1]

                cX = int(np.ceil(x / cntCount))
                cY = int(np.ceil(y / cntCount))
                cv.circle(img, (cX, cY), 2, (0, 255, 0), -1)
            maxArea, maxPos, pos = maxRect(contour, ww, hh, inkX, inkY, inkVink)
            if maxArea == 0:
                break
            estChildrenSize += maxArea
            paintRecRot(img, maxPos, (0, 255, 0), 1)
            # Tegne horisontale linjer
            uVectDrawLine(maxPos[0][0], maxPos[1][0], diagonal, thresh2, lineWidth)
            uVectDrawLine(maxPos[3][0], maxPos[2][0], diagonal, thresh2, lineWidth)
            # Tegne vertikale linjer
            uVectDrawLine(maxPos[0][0], maxPos[2][0], diagonal, thresh3, lineWidth)
            uVectDrawLine(maxPos[1][0], maxPos[3][0], diagonal, thresh3, lineWidth)


    # Boxing all tresholds
    result = thresh2.copy()
    result = cv.merge([result, result, result])
    contours = cv.findContours(thresh2, cv.RETR_EXTERNAL, cv.CHAIN_APPROX_NONE)
    contours = contours[0] if len(contours) == 2 else contours[1]

    ##Thresh2
    result2 = thresh3.copy()
    result2 = cv.merge([result2, result2, result2])
    contours2 = cv.findContours(thresh3, cv.RETR_EXTERNAL, cv.CHAIN_APPROX_NONE)
    contours2 = contours2[0] if len(contours2) == 2 else contours2[1]

    # FindArea
    rectangleSize = 0
    smallArea = 0
    for cnt in contours:
        rect = cv.minAreaRect(cnt)
        box = cv.boxPoints(rect)
        ignore = False
        if not smaaObjekt:
            p, a, l, s = startCorner(box)
            if s < (diameter - overlapp):
                ignore = True
                smallArea += rect[1][0] * rect[1][1]
        if not ignore:
            rectangleSize += rect[1][0] * rect[1][1]

    # FindArea2
    rectangleSize2 = 0
    smallArea2 = 0
    for cnt in contours2:

        rect2 = cv.minAreaRect(cnt)
        box = cv.boxPoints(rect2)
        ignore = False
        if not smaaObjekt:
            p, a, l, s = startCorner(box)
            if s < (diameter - overlapp):
                ignore = True
                smallArea2 += rect2[1][0] * rect2[1][1]
        if not ignore:
            rectangleSize2 += rect2[1][0] * rect2[1][1]

    print("1: Vindu H kutt: ", round(rectangleSize))
    print("2: Vindu V kutt: ", round(rectangleSize2))

    actual_size = max_area_thresh - childrenSize
    prtMld = "Velger 1"
    # Velger metode som gir nærmest 100% overlapp. Begge veier.
    if abs(rectangleSize / actual_size - 1) > abs(rectangleSize2 / actual_size - 1):
        rectangleSize = rectangleSize2
        result = result2
        contours = contours2
        prtMld = "Velger 2"
        smallArea = smallArea2
    print(prtMld)

    bevegelser = []
    for cnt in contours:
        rect = cv.minAreaRect(cnt)
        # Margin around paint boxes. Inc in px
        rect = increment_mar(rect, margin)
        box = cv.boxPoints(rect)
        optimal_box = np.int0(box)
        cv.drawContours(img, [optimal_box], 0, (255, 255, 0),2 )
        ###
        POI = pathPoint(optimal_box, aks, diameter, overlapp, smaaObjekt)
        bevegelser.append(POI)
        if POI == 0:
            print("**ERROR** Objekt er for tynt. Velg <smallObjekts = True>")
            continue
        for i in POI:
            cv.circle(img, tuple(i), 4, (251, 187, 116), 2)

            #j = 0
        for i in range(0, (len(POI) - 1)):
            #j += 1
            # (j-2) % 4 == 0
            if (i - 1) % 4 == 0:
                # Når lakkering skal være på
                img = cv.arrowedLine(img, POI[i], POI[i + 1], (0, 150, 150), 2)
            else:
                # Når det ikke lakkeres
                img = cv.arrowedLine(img, POI[i], POI[i + 1], (0, 0, 255), 2)
        ###


    hConcat = cv.hconcat((result, img))
    # show thresh and result
    #
    resultat = True
    # Tar ikke hensyn til "smaaObjekt"
    if resultat:
        prosentRekt = round(rectangleSize / actual_size * 100, 1)
        if not childrenSize == 0:
            prosentVindu = round(estChildrenSize / childrenSize * 100, 1)
            print("Vindu: ", prosentVindu, "%")

        prosentEnkel = round(storRektangel / actual_size * 100, 1)
        print("Total med vindu: ", prosentRekt, "%")
        print("Total uten vindu: ", prosentEnkel, "%")
        if not smaaObjekt:
            prosentSmallArea = round(smallArea / actual_size, 3)
            print("Ignorert området: ", prosentSmallArea, "%")
        if margin > 0:
            print("**Margin er ikke tatt med i utregning**")
    print(" ")
    #

    outfile = 'genBilder\%s.png' % (name)
    cv.imwrite(outfile, hConcat)
    oppkutt = 'genBilder\%s_oppkutt.png' % (name)
    cv.imwrite(oppkutt, result)
    allInfo = 'genBilder\%s_allInfo.png' % (name)
    cv.imwrite(allInfo, img)
    cv.imshow(name, hConcat)

    def click_event(event, x, y, flags, param):
        if event == cv.EVENT_LBUTTONDOWN:
            print(x, ', ', y)
            font = cv.FONT_HERSHEY_SIMPLEX
            strXY = str(x) + ', ' + str(y)
            cv.putText(hConcat, strXY, (x, y), font, .5, (255, 255, 0), 1)
            cv.imshow(name, hConcat)

    cv.setMouseCallback(name, click_event)

    return bevegelser
