import numpy as np
import cv2 as cv
import math

def maxRect(cnt, ww, hh, incX, incY, degreesTurn):
    # vertical søk
    def findHeight(cnt, cX, cY):
        # find top og bot
        # cX = konst ->   y = variabel
        # starte på topp, og går ned for å sjekke om
        temp_dist = cv.pointPolygonTest(cnt, (cX, 0), True)
        ptTop = [cX, abs(np.round(temp_dist))]
        error = False
        # Finner øverste punkt over cX som er innenfor contouren
        while cv.pointPolygonTest(cnt, tuple(ptTop), False) < 0:
            ptTop[1] += incY
            if ptTop[1] >= cY:
                error = True
                break

        distTop = cY - ptTop[1]
        ptBot = [cX, cY + distTop]

        while cv.pointPolygonTest(cnt, tuple(ptBot), False) < 0:
            ptBot[1] -= incY
            if ptBot[1] <= cY:
                error = True
                break

        distBot = ptBot[1] - cY
        # Avstand fra midt til top/bot
        distY = min(distTop, distBot)
        yTop = cY - distY
        yBot = cY + distY
        return yTop, yBot, distY, error

    # Horizontal søk, danner nå 4 hjørner
    # ptTop == x top punkt, cY = centerpunkt y kordinat, xTop/xBot = x koord top-/bunn-punkt
    # Finner fire punkter som kan danne rektangel. Er ikke sikker om kontur krysser linjene.
    def findSide(cX, yTop, cnt, ww, yBot, cY,):
        # korteste avstand fra punkt sideveis
        # Teste finn korteste sideavstand fra topp og bunn punkt [xTop, y[i]] og [xBunn, y[i]]

        ptTR = [cX, yTop]
        ptTL = [cX, yTop]
        ptBR = [cX, yBot]
        ptBL = [cX, yBot]
        error = False

        # Find longest rightTop side. Start centre move out.
        # x[i++], cY
        while cv.pointPolygonTest(cnt, tuple(ptTR), False) >= 0:
            ptTR[0] += incX
            if ptTR[0] > ww:
                error = True
                print("error in findSide RT")
                break
        ptTR[0] -= incX
        distXTR = ptTR[0] - cX
        ptTL[0] = cX - distXTR

        # Check if right point distant is consistent with left side. If not -> shrink distanse
        # x_new[i++], cY
        while cv.pointPolygonTest(cnt, tuple(ptTL), False) < 0:
            if ptTL[0] > cX:
                error = True
                print("error in findSide TL, point is right for cX")
                ### What to do if this goes true
                break
            ptTL[0] += incX

        distXTL = cX - ptTL[0]
        distXT = min(distXTL, distXTR)

        ###
        while cv.pointPolygonTest(cnt, tuple(ptBR), False) >= 0:
            ptBR[0] += incX
            if ptBR[0] > ww:
                error = True
                print("error in findSide RB")
                break
        ptBR[0] -= incX
        distXBR = ptBR[0] - cX
        ptBL[0] = cX - distXBR

        # Check if right point distant is consistent with left side. If not -> shrink distanse
        # x_new[i++], cY
        while cv.pointPolygonTest(cnt, tuple(ptBL), False) < 0:
            ptBL[0] += incX
            if ptBL[0] > cX:
                error = True
                print("error in findSide LB")
                break
        distXBL = cX - ptBL[0]
        distXB = min(distXBL, distXBR)
        distX = min(distXT,distXB)
        ###
        return distX, error

    def testSide(distX, yTop, yBot, cnt, cX):
        # test om hele siden er innenfor
        # ved feil, kjør gjennom og finner lengste avstand til polygon.
        # test på nytt
        # ved ingen error:
        # test andre side
        distX = int(distX)
        dist = 0
        dist_1 = 0

        #inc = 5
        # Kan få raskere kjøretid ved å øke incY med f.eks incY*2, eller 5
        # For loop tester høyre side
        for y in range(yTop, yBot, inc):
            dist_1 = cv.pointPolygonTest(cnt, (cX + distX, y), True)
            # måler leste feil avstand
            # edit:   må få minste avstand. Ved rotasjon kan det hende at "dist" aldri når 0
            if dist_1 < 0:
                if dist < abs(dist_1):
                    dist = abs(dist_1)

        # skal bare gå vidre om det ikke er registrert feil
        if dist == 0:
            # For loop tester venstre side
            for y in range(yTop, yBot, inc):
                dist_1 = cv.pointPolygonTest(cnt, (cX - distX, y), True)

                if dist_1 < 0:
                    if dist < abs(dist_1):
                        dist = abs(dist_1)


        ## skal returne enten distL eller distR. Noe som er feil med dist:
        return dist

#avg av alle punkter i kontur
    def findCoM(cnt):
        cntCount = len(cnt)
        avg_x = 0
        avg_y = 0

        for kp in cnt:
            avg_x = avg_x + kp[0][0]
            avg_y = avg_y + kp[0][1]

        cX = int(np.ceil(avg_x / cntCount))
        cY = int(np.ceil(avg_y / cntCount))

        return cX, cY
# Funksjonen har avrundingsfeil
    def rotateCnt(cnt, pnt, angle):
        ########################################
        # Fra: https://medium.com/analytics-vidhya/tutorial-how-to-scale-and-rotate-contours-in-opencv-using-python-f48be59c35a2
        ########################################
        def cart2pol(x, y):
            theta = np.arctan2(y, x)
            rho = np.hypot(x, y)
            return theta, rho

        def pol2cart(theta, rho):
            x = rho * np.cos(theta)
            y = rho * np.sin(theta)
            return x, y

        cx = pnt[0]
        cy = pnt[1]

        cnt_norm = cnt - [cx, cy]

        coordinates = cnt_norm[:, 0, :]
        xs, ys = coordinates[:, 0], coordinates[:, 1]
        thetas, rhos = cart2pol(xs, ys)

        thetas = np.rad2deg(thetas)
        thetas = (thetas + angle) % 360
        thetas = np.deg2rad(thetas)

        xs, ys = pol2cart(thetas, rhos)

        cnt_norm[:, 0, 0] = xs
        cnt_norm[:, 0, 1] = ys

        cnt_rotated = cnt_norm + [cx, cy]

        return cnt_rotated


    ###############################################################
    maxArea = 0
    maxAngle = 0
    lstPos = []
    maxPoints = [0,0,0,0]
    # Avstand mellom piksel som testes under testSides:
    inc = 5
    ###############################################################
    # find centre of shape
    cX, cY = findCoM(cnt)
    cntOrg = cnt
    diagonal = math.sqrt(ww**2 + hh**2)

    for angle in range(0, 90, degreesTurn):
        cnt = rotateCnt(cntOrg,(cX,cY), angle)


        ########################################
        #Finne startpunkt
        yTop, yBot, distY, error = findHeight(cnt, cX, cY)

        # Fra toppunkt tar nærmeste avstand til polygon. Ikke nødvendigvis på denne linjen, men en god pekepinn.
        if error:
            print("ERROR in maxRect")
        else:
            for i in range(int(distY), int(incY), int(-incY)):
                # update values
                yTop = cY - i
                yBot = cY + i

                distX, error = findSide(cX, yTop, cnt, ww, yBot, cY)
                dist = testSide(distX, yTop, yBot, cnt, cX)
                distX -= dist

                j = 0
                while not dist == 0:
                    j += inc
                    dist = testSide(distX, yTop, yBot, cnt, cX)
                    distX -= dist

                    # for å optimalisere, bytt ut diagonal med lengste bredde av kontur.
                    if j > diagonal:
                        error = True
                        print("error  Angle: ", angle)
                        break
                if error:
                    break
                width = distX * 2
                height = i * 2
                pos = [cX, cY, height, width]
                lstPos.append(pos)
                area = width * height
                if area > maxArea:
                    maxArea = area
                    maxPos = [cX, cY, height, width]
                    maxPoints[0], maxPoints[1], maxPoints[2], maxPoints[3] = infoToPoints(maxPos)
                    maxAngle = angle
            if error:
                error = False
                continue

    lst = np.empty(len(maxPoints)*2, dtype=int).reshape((len(maxPoints), 1, 2))
    for i, line in enumerate(lst):
        lst[i] = maxPoints[i]
    maxPointsRot = rotateCnt(lst, (cX, cY), -maxAngle)

    if maxAngle == 0:
        maxPointsRot = lst

    if error:
        print("******error detected*******")
    return maxArea, maxPointsRot, lstPos



def infoToPoints(pos):
    pntTL = (int(round(pos[0] - (pos[3] / 2))), (int(round(pos[1] - (pos[2] / 2)))))
    pntTR = (int(round(pos[0] + (pos[3] / 2))), (int(round(pos[1] - (pos[2] / 2)))))
    pntBL = (int(round(pos[0] - (pos[3] / 2))), (int(round(pos[1] + (pos[2] / 2)))))
    pntBR = (int(round(pos[0] + (pos[3] / 2))), (int(round(pos[1] + (pos[2] / 2)))))

    return pntTL, pntTR, pntBL, pntBR